diff mbox

[v3] overlay: test unstable inode number

Message ID 1481532306-26938-1-git-send-email-amir73il@gmail.com (mailing list archive)
State New, archived
Headers show

Commit Message

Amir Goldstein Dec. 12, 2016, 8:45 a.m. UTC
Introduce a new test to demonstrate a known issue with overlayfs:
- stat file A shows inode number X
- modify A to trigger copy up
- stat file A shows inode number Y != X

Also test if d_ino of readdir entries changes after copy up.

There is a POC patch by Miklos Szeredi that fixes this issue.

Not dealing with hardlinks here, because there is more to test
then stable inode number.
Hardlinks will get a test of their own.
---
 tests/overlay/018     | 101 ++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/overlay/018.out |   7 ++++
 tests/overlay/group   |   1 +
 3 files changed, 109 insertions(+)
 create mode 100755 tests/overlay/018
 create mode 100644 tests/overlay/018.out

v3:
- test also special device files
- document not testing hardlinks

v2:
- use arbitrary uid for chown

Comments

Eryu Guan Dec. 12, 2016, 9:08 a.m. UTC | #1
On Mon, Dec 12, 2016 at 10:45:06AM +0200, Amir Goldstein wrote:
> Introduce a new test to demonstrate a known issue with overlayfs:
> - stat file A shows inode number X
> - modify A to trigger copy up
> - stat file A shows inode number Y != X
> 
> Also test if d_ino of readdir entries changes after copy up.
> 
> There is a POC patch by Miklos Szeredi that fixes this issue.
> 
> Not dealing with hardlinks here, because there is more to test
> then stable inode number.
> Hardlinks will get a test of their own.

Thanks! I added the missing SOB line, and added "copyup" group too.

Eryu
--
To unsubscribe from this list: send the line "unsubscribe fstests" in
the body of a message to majordomo@vger.kernel.org
More majordomo info at  http://vger.kernel.org/majordomo-info.html
Amir Goldstein Dec. 12, 2016, 9:21 a.m. UTC | #2
On Mon, Dec 12, 2016 at 11:08 AM, Eryu Guan <eguan@redhat.com> wrote:
> On Mon, Dec 12, 2016 at 10:45:06AM +0200, Amir Goldstein wrote:
>> Introduce a new test to demonstrate a known issue with overlayfs:
>> - stat file A shows inode number X
>> - modify A to trigger copy up
>> - stat file A shows inode number Y != X
>>
>> Also test if d_ino of readdir entries changes after copy up.
>>
>> There is a POC patch by Miklos Szeredi that fixes this issue.
>>
>> Not dealing with hardlinks here, because there is more to test
>> then stable inode number.
>> Hardlinks will get a test of their own.
>
> Thanks! I added the missing SOB line, and added "copyup" group too.
>

Right. Thanks.
I audited existing tests and I believe my 016 also calls for "copyup" tag
and 013 as well.
Do you want a patch for that or will you fix it up yourself?

Amir.
--
To unsubscribe from this list: send the line "unsubscribe fstests" in
the body of a message to majordomo@vger.kernel.org
More majordomo info at  http://vger.kernel.org/majordomo-info.html
Eryu Guan Dec. 12, 2016, 9:26 a.m. UTC | #3
On Mon, Dec 12, 2016 at 11:21:48AM +0200, Amir Goldstein wrote:
> On Mon, Dec 12, 2016 at 11:08 AM, Eryu Guan <eguan@redhat.com> wrote:
> > On Mon, Dec 12, 2016 at 10:45:06AM +0200, Amir Goldstein wrote:
> >> Introduce a new test to demonstrate a known issue with overlayfs:
> >> - stat file A shows inode number X
> >> - modify A to trigger copy up
> >> - stat file A shows inode number Y != X
> >>
> >> Also test if d_ino of readdir entries changes after copy up.
> >>
> >> There is a POC patch by Miklos Szeredi that fixes this issue.
> >>
> >> Not dealing with hardlinks here, because there is more to test
> >> then stable inode number.
> >> Hardlinks will get a test of their own.
> >
> > Thanks! I added the missing SOB line, and added "copyup" group too.
> >
> 
> Right. Thanks.
> I audited existing tests and I believe my 016 also calls for "copyup" tag
> and 013 as well.
> Do you want a patch for that or will you fix it up yourself?

Please send a new patch to fix them. Thanks!

Eryu
--
To unsubscribe from this list: send the line "unsubscribe fstests" in
the body of a message to majordomo@vger.kernel.org
More majordomo info at  http://vger.kernel.org/majordomo-info.html
diff mbox

Patch

diff --git a/tests/overlay/018 b/tests/overlay/018
new file mode 100755
index 0000000..230245b
--- /dev/null
+++ b/tests/overlay/018
@@ -0,0 +1,101 @@ 
+#! /bin/bash
+# FSQA Test No. 018
+#
+# Test unstable inode number
+#
+# This simple test demonstrates a known issue with overlayfs:
+# - stat file A shows inode number X
+# - modify A to trigger copy up
+# - stat file A shows inode number Y != X
+#
+# Also test if d_ino of readdir entries changes after copy up.
+#
+#-----------------------------------------------------------------------
+#
+# Copyright (C) 2016 CTERA Networks. All Rights Reserved.
+# Author: Amir Goldstein <amir73il@gmail.com>
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+tmp=/tmp/$$
+status=1	# failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+	cd /
+	rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# real QA test starts here
+_supported_fs overlay
+_supported_os Linux
+_require_scratch
+
+rm -f $seqres.full
+
+_scratch_mkfs >>$seqres.full 2>&1
+
+# Create our test files.
+# Not dealing with hardlinks here, because there is more to test
+# then stable inode number.
+# Hardlinks will get a test of their own.
+lowerdir=$SCRATCH_DEV/$OVERLAY_LOWER_DIR
+mkdir -p $lowerdir
+mkdir $lowerdir/dir
+touch $lowerdir/file
+ln -s $lowerdir/file $lowerdir/symlink
+mknod $lowerdir/chrdev c 1 1
+mknod $lowerdir/blkdev b 1 1
+mknod $lowerdir/fifo p
+
+
+_scratch_mount
+
+cd $SCRATCH_MNT
+
+rm -f $tmp.before $tmp.after
+
+# Test stable stat(2) st_ino
+
+# Record inode numbers before and after copy up
+for f in dir file symlink chrdev blkdev fifo; do
+	ls -id $f >> $tmp.before
+	# chown -h modifies all those file types
+	chown -h 100 $f
+	ls -id $f >> $tmp.after
+done
+
+# Test stable readdir(3)/getdents(2) d_ino
+
+# find by inode number - expect to find file by inode number
+cat $tmp.before | while read ino f; do
+	find $f -inum $ino -maxdepth 0
+done
+
+# Compare before..after - expect silence
+diff $tmp.before $tmp.after
+
+status=0
+exit
diff --git a/tests/overlay/018.out b/tests/overlay/018.out
new file mode 100644
index 0000000..bf4bce8
--- /dev/null
+++ b/tests/overlay/018.out
@@ -0,0 +1,7 @@ 
+QA output created by 018
+dir
+file
+symlink
+chrdev
+blkdev
+fifo
diff --git a/tests/overlay/group b/tests/overlay/group
index 5740d2a..683b2fc 100644
--- a/tests/overlay/group
+++ b/tests/overlay/group
@@ -19,3 +19,4 @@ 
 014 auto quick copyup
 015 auto quick whiteout
 016 auto quick
+018 auto quick